package 
{
	import com.flashtuts.lib.data.AMFPHPService;
	import com.flashtuts.lib.display.ui.Button;
	import com.flashtuts.lib.display.ui.InputTextArea;
	import com.flashtuts.lib.display.ui.InputTextField;
	import com.flashtuts.lib.events.RemoteConnectionServiceEvent;
	
	import flash.display.GradientType;
	import flash.display.Sprite;
	import flash.events.MouseEvent;
	import flash.geom.Matrix;
	import flash.text.Font;
	import flash.text.TextFormat;

	[SWF( width='600', height='400', frameRate='30', backgroundColor='#000000' )]

	public class App extends Sprite
	{	
		private var service:AMFPHPService						= new AMFPHPService( 'http://dev.ahmednuaman.com/amfphp/gateway.php' );
		private var textField:InputTextField 					= new InputTextField();
		private var textArea:InputTextArea 						= new InputTextArea();
		
		[Embed( systemFont='Arial', fontName='Arial', mimeType='application/x-font' )]
		private var arialFont:Class;
		
		public function App()
		{
			init();
		}

		private function init():void
		{
			var mat:Matrix = new Matrix();
			var bg:Sprite = new Sprite();

			mat.createGradientBox( stage.stageWidth, stage.stageHeight, Math.PI * .5 );

			bg.graphics.beginGradientFill( GradientType.LINEAR, [ 0x333333, 0x000000 ], [ 1, 1 ], [ 0, 255 ], mat );
			bg.graphics.drawRect( 0, 0, stage.stageWidth, stage.stageHeight );
			bg.graphics.endFill();

			addChild( bg );

			Font.registerFont( arialFont );
			
			addTextField();
			
			service.addEventListener( RemoteConnectionServiceEvent.READY, handleDataReady );
		}
		
		private function addTextField():void
		{
			var format:TextFormat = new TextFormat( 'Arial', 12, 0x000000 );
			var button:Button = new Button();
			
			textField.init( format, 200, 25, 0xFFFFFF, 1, 0x333333, 10 );
			
			textField.text = 'Hello';
			
			addChild( textField );
			
			textArea.init( format, 300, 200, 0xFFFFFF, 1, 0x333333, 10 );
			
			textArea.text = 'Text will appear here that\'s returned from the server!';
			
			addChild( textArea );
			
			button.init( 'Click on me!', format, 0xCCCCCC, 1, 0x333333, 10 );
			
			button.addEventListener( MouseEvent.CLICK, handleButtonClick );
			
			addChild( button );
			
			textField.x = ( stage.stageWidth / 2 ) - ( ( textField.width + button.width + 20 ) / 2 );
			textField.y = 20;
			
			button.x = textField.x + textField.width + 20;
			button.y = 20;
			
			textArea.x = ( stage.stageWidth / 2 ) - ( textArea.width / 2 );
			textArea.y = 60;
		}
		
		private function handleButtonClick(e:MouseEvent):void
		{
			service.send( 'CI.execute', 'main', [ textField.text, 'another var', 1, 0xFFFFFF, { data: 'test', data2: 'test2' } ] );
		}
		
		private function handleDataReady(e:RemoteConnectionServiceEvent):void
		{
			textArea.text = e.data.toString();
		}
	}
}