package com.flashtuts.lib.data
{
	import com.flashtuts.lib.events.RemoteConnectionServiceEvent;
	
	import flash.events.NetStatusEvent;
	import flash.net.NetConnection;
	import flash.net.Responder;

	public class RemoteConnectionService extends NetConnection
	{	
		public var handleReady:Boolean							= true;
		
		public var data:Object;
		public var gatewayURL:String;
		public var responder:Responder;
		
		private var loadedEvent:String;
		private var readyEvent:String;
		private var faultEvent:String;
		
		public function RemoteConnectionService(gatewayURL:String, loadedEvent:String='', readyEvent:String='', faultEvent:String='', encoding:uint=3)
		{
			this.gatewayURL = gatewayURL;
			this.loadedEvent = loadedEvent;
			this.readyEvent = readyEvent;
			this.faultEvent = faultEvent;
			
			objectEncoding = encoding;
			
			if ( gatewayURL )
			{						
				responder = new Responder( handleResponseResult, handleResponseFault );
				
				addEventListener( NetStatusEvent.NET_STATUS, handleNetEvent );
				
				connect( gatewayURL );
			}
		}
		
		public function send(method:String, ... args):void
		{
			call.apply( null, [ method, responder ].concat( args ) );
		}
		
		private function handleNetEvent(e:NetStatusEvent):void
		{
			dispatchEvent( new RemoteConnectionServiceEvent( faultEvent, e.info.code ) );
		}
		
		private function handleResponseResult(data:Object):void
		{			
			dispatchEvent( new RemoteConnectionServiceEvent( loadedEvent, data ) );
			
			if ( handleReady )
			{
				handleLoaderDataReady( data );
			}
		}
		
		public function handleLoaderDataReady(data:Object):void
		{
			this.data = data;
			
			dispatchEvent( new RemoteConnectionServiceEvent( readyEvent, data ) );
		}
		
		private function handleResponseFault(data:Object):void
		{
			dispatchEvent( new RemoteConnectionServiceEvent( faultEvent, data ) );
		}
	}
}