package com.flashtuts.lib.display.ui
{
	import flash.display.Sprite;
	import flash.text.TextField;
	import flash.text.TextFieldAutoSize;
	import flash.text.TextFormat;

	public class Button extends Sprite
	{
		private var bg:Sprite;
		private var field:TextField;
		
		public function Button()
		{
			this.buttonMode = true;
			this.mouseChildren = false;
			
			bg = new Sprite();
			
			addChild( bg );
			
			field = new TextField();
			
			addChild( field );
		}
		
		public function init(text:String, format:TextFormat, backgroundColour:uint=0, strokeThickness:Number=0, strokeColour:uint=0, cornerRadius:Number=0, padding:Number=4):void
		{
			field.autoSize = TextFieldAutoSize.LEFT;
			field.defaultTextFormat = format;
			field.embedFonts = true;
			field.mouseEnabled = false;
			field.text = text;
			field.x = padding;
			field.y = padding;
			
			bg.graphics.clear();
			bg.graphics.lineStyle( strokeThickness, strokeColour );
			bg.graphics.beginFill( backgroundColour );
			bg.graphics.drawRoundRect( 0, 0, field.width + ( padding * 2 ), field.height + ( padding * 2 ), cornerRadius );
			bg.graphics.endFill();
		}
	}
}