package com.flashtuts.lib.display.ui
{
	import flash.display.Sprite;
	import flash.text.TextField;
	import flash.text.TextFieldAutoSize;
	import flash.text.TextFieldType;
	import flash.text.TextFormat;

	public class InputTextField extends Sprite
	{
		private var minWidth:Number								= 200;
		
		private var bg:Sprite;
		private var field:TextField;
		
		public function InputTextField()
		{
			bg = new Sprite();
			
			addChild( bg );
			
			field = new TextField();
			
			addChild( field );
		}
		
		public function init(format:TextFormat, width:Number=0, height:Number=0, backgroundColour:uint=0, strokeThickness:Number=0, strokeColour:uint=0, cornerRadius:Number=0, padding:Number=4):void
		{
			field.autoSize = TextFieldAutoSize.LEFT;
			field.defaultTextFormat = format;
			field.embedFonts = true;
			field.type = TextFieldType.INPUT;
			field.width = ( width > 0 ? width - ( padding * 2 ) : minWidth );
			field.x = padding;
			field.y = padding;
			
			bg.graphics.clear();
			bg.graphics.lineStyle( strokeThickness, strokeColour );
			bg.graphics.beginFill( backgroundColour );
			bg.graphics.drawRoundRect( 0, 0, ( width > 0 ? width : field.width + ( padding * 2 ) ), ( height > 0 ? height : field.height + ( padding * 2 ) ), cornerRadius );
			bg.graphics.endFill();
		}
		
		public function set text(text:String):void
		{
			field.text = text;
		}
		
		public function get text():String
		{
			return field.text;
		}
	}
}